<?php

const SITENAME = 'Site Name Here'; // Replace with your site name
const SITE_URL = 'https://'; // Replace with your domain
const MUSIC_ARTWORK = 'artwork.jpg'; // Replace with your default music cover

error_reporting(0);

function sanitize($str) {
    $str = strip_tags($str);
    $str = html_entity_decode($str);
    return trim($str);
}

$shownUrl = '';
$url = '';
$genre = '';
$artiste = '';
$title = '';
$album = '';
$producer = '';
$jingle = '';
$sequence = '';
$filename = '';
$artworkUrl = '';
$externalArtwork = '';

require('getid3/getid3.php');
if (isset($_POST['submit'])) {
    $url = !empty($_POST['url']) ? filter_var($_POST['url'], FILTER_SANITIZE_URL) : '';
    $genre = !empty($_POST['genre']) ? sanitize($_POST['genre']) : '';
    $artiste = !empty($_POST['artiste']) ? sanitize($_POST['artiste']) : '';
    $title = !empty($_POST['title']) ? sanitize($_POST['title']) : '';
    $album = !empty($_POST['album']) ? sanitize($_POST['album']) : '';
    $producer = !empty($_POST['producer']) ? sanitize($_POST['producer']) : '';
    $jingle = isset($_POST['jingle']) ? $_POST['jingle'] : 0;
    $sequence = isset($_POST['sequence']) ? $_POST['sequence'] : 'start_middle_end';
    $filename = !empty($_POST['filename']) ? sanitize($_POST['filename']) : '';
    $artworkUrl = !empty($_POST['artwork']) ? sanitize($_POST['artwork']) : MUSIC_ARTWORK;
    $externalArtwork = !empty($_POST['external_artwork']) ? sanitize($_POST['external_artwork']) : '';

    $now = time();
    $default_mp3_directory = "../wp-content/uploads/";
    $default_album = "@" . SITENAME;
    $default_year = date("Y", $now);
    $default_genre = SITENAME;
    $default_producer = '';
    $default_cover = './' . $artworkUrl;
    $shownUrl .= SITE_URL . '/wp-content/uploads/';

    $mp3_filepath = $url;
    $mp3_songname = $title;
    $mp3_comment = "Downloaded from " . SITENAME;
    $mp3_artist = $artiste;

    $mp3_filename = empty($filename) ? $mp3_artist . ' - ' . $mp3_songname : $filename;
    $mp3_album = empty($album) ? $default_album : $album;
    $mp3_year = empty($_POST['year']) || !is_numeric($_POST['year']) || strlen($_POST['year']) != 4 ? $default_year : $_POST['year'];
    $mp3_genre = empty($genre) ? $default_genre : $genre;
    $extra = array(
        'year' => $mp3_year,
        'genre' => $genre,
        'album' => $album,
        'producer' => !empty($producer) ? $producer : $default_producer
    );
    $error = '';

    if (!filter_var($mp3_filepath, FILTER_VALIDATE_URL)) {
        $error .= 'Invalid File URL<br>';
    } else if (empty($mp3_filename) || empty($mp3_songname) || empty($mp3_artist)) {
        $error .= "Fields Marked * Are Required<br>";
    } else if (!file_exists($default_cover)) {
        $error .= 'The Photo Cover Has Not Been Uploaded';
    } else {
        $timeFolder = date('Y', $now) . '/' . date('m', $now) . '/';

        if (!file_exists($default_mp3_directory . $timeFolder)) {
            mkdir($default_mp3_directory . $timeFolder, 0777, true);
        }

        $storeName = str_replace(' ', '-', $mp3_filename);
        $storeName = preg_replace('/[^A-Za-z0-9\-]/', '', $storeName);
        $storeName = preg_replace('/-+/', '-', $storeName);
        $storeName .= '-(' . SITENAME . ').mp3';
        $sname = $default_mp3_directory . $timeFolder . $storeName;

        if (file_exists($sname)) {
            $error = 'File Has Already Been Uploaded As <a href="' . $shownUrl . $timeFolder . $storeName . '">' . $storeName . '</a>';
        } else {
            if (copy($mp3_filepath, $sname)) {
                // FFmpeg jingle insertion and tagging
                if ($jingle == '1') {
                    $jingleFile = '/jingle.mp3'; // Replace with actual jingle path
                    $outputFile = $sname;

                    switch ($sequence) {
                        case 'start':
                            exec("ffmpeg -i $sname -i $jingleFile -filter_complex '[0]adelay=10000|10000[a];[1][a]amix=inputs=2[aout]' -map '[aout]' $outputFile");
                            break;
                        case 'middle':
                            exec("ffmpeg -i $sname -i $jingleFile -filter_complex '[0]atrim=duration=60[main];[1]adelay=60000|60000[jingle];[main][jingle]amix=inputs=2[aout]' -map '[aout]' $outputFile");
                            break;
                        case 'end':
                            exec("ffmpeg -i $sname -i $jingleFile -filter_complex '[0][1]amix=inputs=2[aout]' -map '[aout]' $outputFile");
                            break;
                        case 'start_middle_end':
                            exec("ffmpeg -i $sname -i $jingleFile -filter_complex '[0]adelay=10000|10000[a];[1]adelay=60000|60000[jingle];[a][jingle]amix=inputs=2[aout]' -map '[aout]' $outputFile");
                            break;
                        default:
                            exec("ffmpeg -i $sname -i $jingleFile -filter_complex '[0][1]amix=inputs=2[aout]' -map '[aout]' $outputFile");
                            break;
                    }
                    $sname = $outputFile;
                }

                // Write ID3 tags
                $mp3_tagformat = 'UTF-8';
                $mp3_handler = new getID3();
                $mp3_handler->setOption(array('encoding' => $mp3_tagformat));

                require('getid3/write.php');
                $mp3_writer = new getid3_writetags;
                $mp3_writer->filename = $sname;
                $mp3_writer->tagformats = array('id3v1', 'id3v2.3');
                $mp3_writer->overwrite_tags = true;
                $mp3_writer->tag_encoding = $mp3_tagformat;
                $mp3_writer->remove_other_tags = true;

                $mp3_data['title'][] = $mp3_songname . ' | ' . SITENAME;
                $mp3_data['artist'][] = $mp3_artist;
                $mp3_data['album'][] = $mp3_album;
                $mp3_data['year'][] = $mp3_year;
                $mp3_data['genre'][] = $mp3_genre;
                $mp3_data['comment'][] = $mp3_comment;

                // Use external artwork if provided, otherwise use the default
                $coverToUse = !empty($externalArtwork) ? $externalArtwork : $default_cover;
                $mp3_data['attached_picture'][0]['data'] = file_get_contents($coverToUse);
                $mp3_data['attached_picture'][0]['picturetypeid'] = 3;
                $mp3_data['attached_picture'][0]['description'] = "Downloaded from " . SITENAME;
                $mp3_data['attached_picture'][0]['mime'] = "image/jpeg";
                $mp3_writer->tag_data = $mp3_data;

                if ($mp3_writer->WriteTags()) {
                    $link = $sname;
                    $shownUrl .= $timeFolder . $storeName;
                } else {
                    unlink($sname);
                    $error .= "Failed To Write Tags!<br><br><em>" . implode("<br><br>", $mp3_writer->errors) . '</em><br>';
                }
            } else {
                $error .= "Unable To Copy File please contact admin";
            }
        }
    }
}

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <title><?php echo SITENAME; ?> Music Upload Via URL</title>
    <meta name="robots" content="noindex, nofollow">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet">
    <style>
        body {
            background: linear-gradient(135deg, #f5f7fa, #c3cfe2);
            min-height: 100vh;
            display: flex;
            align-items: center;
            justify-content: center;
            padding: 20px;
        }

        .wrapper {
            background: #fff;
            padding: 2rem;
            border-radius: 10px;
            box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
            width: 100%;
            max-width: 800px;
        }

        .form-control {
            border-radius: 5px;
            border: 1px solid #ddd;
            padding: 10px;
        }

        .btn-primary {
            background-color: #3366cc;
            border: none;
            padding: 10px 20px;
            border-radius: 5px;
            transition: background-color 0.3s ease;
        }

        .btn-primary:hover {
            background-color: #254e80;
        }

        .error {
            background-color: #ffebee;
            color: #c62828;
            padding: 10px;
            border-radius: 5px;
            margin-bottom: 1rem;
        }

        .successbox {
            background-color: #e8f5e9;
            color: #2e7d32;
            padding: 10px;
            border-radius: 5px;
            margin-bottom: 1rem;
        }

        .successbox input[type="text"] {
            width: 100%;
            padding: 5px;
            border-radius: 5px;
            border: 1px solid #ddd;
        }
    </style>
</head>
<body>
<div class="wrapper">
    <h1 class="text-center mb-4">Welcome To <?php echo SITENAME; ?> Upload Panel</h1>
    <?php if (isset($link) && !empty($link)) { ?>
        <div class="successbox">
            <p>File Uploaded Successfully</p>
            <input type="text" value="<?php echo $shownUrl; ?>" readonly>
        </div>
    <?php } else { ?>
        <?php if (!empty($error)) { ?>
            <div class="error"><?php echo $error; ?></div>
        <?php } ?>
        <form method="post" action="<?php echo htmlspecialchars($_SERVER['REQUEST_URI']); ?>">
            <div class="mb-3">
                <label for="url" class="form-label">Link</label>
                <input type="text" class="form-control" id="url" name="url" value="<?php echo $url; ?>" required>
                <small class="form-text text-muted">*Required : URL To File (e.g https://www.mysite.com/music.mp3)</small>
            </div>
            <div class="mb-3">
                <label for="artiste" class="form-label">Artiste</label>
                <input type="text" class="form-control" id="artiste" name="artiste" value="<?php echo htmlentities($artiste); ?>" required>
                <small class="form-text text-muted">*Required : Artiste's Name (e.g Eminem)</small>
            </div>
            <div class="mb-3">
                <label for="title" class="form-label">Title</label>
                <input type="text" class="form-control" id="title" name="title" value="<?php echo htmlentities($title); ?>" required>
                <small class="form-text text-muted">*Required : Track Name (e.g Crack A Bottle (ft. 50Cent & Dr Dre))</small>
            </div>
            <div class="mb-3">
                <label for="album" class="form-label">Album</label>
                <input type="text" class="form-control" id="album" name="album" value="<?php echo htmlentities($album); ?>">
                <small class="form-text text-muted">Optional</small>
            </div>
            <div class="mb-3">
                <label for="producer" class="form-label">Producer</label>
                <input type="text" class="form-control" id="producer" name="producer" value="<?php echo htmlentities($producer); ?>">
                <small class="form-text text-muted">Optional</small>
            </div>
            <div class="mb-3">
                <label for="external_artwork" class="form-label">External Music Artwork Link</label>
                <input type="url" class="form-control" id="external_artwork" name="external_artwork" value="<?php echo htmlentities($externalArtwork); ?>">
                <small class="form-text text-muted">Optional: URL for external artwork</small>
            </div>
            <div class="mb-3">
                <label for="jingle" class="form-label">Add Jingle</label>
                <select class="form-select" id="jingle" name="jingle">
                    <option value="1" <?php echo ($jingle == '1' ? 'selected' : ''); ?>>Yes</option>
                    <option value="0" <?php echo ($jingle == '0' ? 'selected' : ''); ?>>No</option>
                </select>
            </div>
            <div class="mb-3">
                <label for="sequence" class="form-label">Jingle Sequence</label>
                <select class="form-select" id="sequence" name="sequence">
                    <option value="start_middle_end" <?php echo ($sequence == 'start_middle_end' ? 'selected' : ''); ?>>Start, Middle, End</option>
                    <option value="start" <?php echo ($sequence == 'start' ? 'selected' : ''); ?>>Start</option>
                    <option value="middle" <?php echo ($sequence == 'middle' ? 'selected' : ''); ?>>Middle</option>
                    <option value="end" <?php echo ($sequence == 'end' ? 'selected' : ''); ?>>End</option>
                </select>
            </div>
            <button type="submit" class="btn btn-primary w-100" name="submit">Upload Music</button>
        </form>
    <?php } ?>
</div>
</body>
</html>